﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OpenAccessRuntime.Relational;
using Telerik.OpenAccess.SPI;

namespace SchemaReader
{
    public class OpenAccessSchemaReader
    {
        private Telerik.OpenAccess.BackendConfiguration backendConfiguration;
        private string connectionString;
        public OpenAccessSchemaReader(Telerik.OpenAccess.BackendConfiguration backendConfiguration, string connectionString)
        {
            this.backendConfiguration = backendConfiguration;
            this.connectionString = connectionString;
        }

        internal ISchemaReader schemaReader;
        internal ISchemaReader SchemaReader
        {
            get
            {
                if (this.schemaReader == null)
                {
                    this.schemaReader = this.CreateSchemaReader();
                }
                return this.schemaReader;
            }
            set
            {
                this.schemaReader = value;
            }
        }

        internal ISchemaReader CreateSchemaReader()
        {
            string driver = backendConfiguration.Driver;
            if (!string.IsNullOrEmpty(driver))
            {
                driver = string.Format(";Driver={0}", driver);
            }

            string url = string.Format("Backend={0}{1};connectionstring={2}", backendConfiguration.Backend, driver, connectionString);
            return MappingHandler.GetSchemaReader(url, backendConfiguration.ProviderName);

        }

        public string[] GetSchemas()
        {
            return this.SchemaReader.GetSchemas();
        }

        public string ReadSchema(SchemaReadParameters parameters)
        {
            var metaDataContainer = this.SchemaReader.GetSchema(parameters);
            return metaDataContainer.ToString();
        }
    }
}
